ghc-7.10.3: The GHC API

Safe Haskell | None
Language | Haskell2010

IfaceEnv

Synopsis

- newGlobalBinder :: Module -> OccName -> SrcSpan -> TcRnIf a b Name
- newImplicitBinder :: Name -> (OccName -> OccName) -> TcRnIf m n Name
- lookupIfaceTop :: OccName -> IfL Name
- lookupOrig :: Module -> OccName -> TcRnIf a b Name
- lookupOrigNameCache :: OrigNameCache -> Module -> OccName -> Maybe Name
- extendNameCache :: OrigNameCache -> Module -> OccName -> Name -> OrigNameCache
- newIfaceName :: OccName -> IfL Name
- newIfaceNames :: [OccName] -> IfL [Name]
- extendIfaceIdEnv :: [Id] -> IfL a -> IfL a
- extendIfaceTyVarEnv :: [TyVar] -> IfL a -> IfL a
- tcIfaceLclId :: FastString -> IfL Id
- tcIfaceTyVar :: FastString -> IfL TyVar
- lookupIfaceTyVar :: FastString -> IfL (Maybe TyVar)
- ifaceExportNames :: [IfaceExport] -> TcRnIf gbl lcl [AvailInfo]
- allocateGlobalBinder :: NameCache -> Module -> OccName -> SrcSpan -> (NameCache, Name)
- initNameCache :: UniqSupply -> [Name] -> NameCache
- updNameCache :: (NameCache -> (NameCache, c)) -> TcRnIf a b c
- getNameCache :: TcRnIf a b NameCache
- mkNameCacheUpdater :: TcRnIf a b NameCacheUpdater
- newtype NameCacheUpdater = NCU {
  - updateNameCache :: forall c. (NameCache -> (NameCache, c)) -> IO c
  }

# Documentation

newGlobalBinder :: Module -> OccName -> SrcSpan -> TcRnIf a b Name

newImplicitBinder :: Name -> (OccName -> OccName) -> TcRnIf m n Name

lookupIfaceTop :: OccName -> IfL Name

lookupOrig :: Module -> OccName -> TcRnIf a b Name

lookupOrigNameCache :: OrigNameCache -> Module -> OccName -> Maybe Name

extendNameCache :: OrigNameCache -> Module -> OccName -> Name -> OrigNameCache

newIfaceName :: OccName -> IfL Name

newIfaceNames :: [OccName] -> IfL [Name]

extendIfaceIdEnv :: [Id] -> IfL a -> IfL a

extendIfaceTyVarEnv :: [TyVar] -> IfL a -> IfL a

tcIfaceLclId :: FastString -> IfL Id

tcIfaceTyVar :: FastString -> IfL TyVar

lookupIfaceTyVar :: FastString -> IfL (Maybe TyVar)

ifaceExportNames :: [IfaceExport] -> TcRnIf gbl lcl [AvailInfo]

allocateGlobalBinder :: NameCache -> Module -> OccName -> SrcSpan -> (NameCache, Name)

initNameCache :: UniqSupply -> [Name] -> NameCache

updNameCache :: (NameCache -> (NameCache, c)) -> TcRnIf a b c

getNameCache :: TcRnIf a b NameCache

mkNameCacheUpdater :: TcRnIf a b NameCacheUpdater

Return a function to atomically update the name cache.

newtype NameCacheUpdater

A function that atomically updates the name cache given a modifier function. The second result of the modifier function will be the result of the IO action.

Constructors

NCU |

Fields

updateNameCache :: forall c. (NameCache -> (NameCache, c)) -> IO c